//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#include "TUniverse.cpp"
#pragma hdrstop

#include "TGenBox.h"
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TGenBox *GenBox;
extern TUniverse *Universe;
extern int LastGen;
double R0,R1;
double X0,X1,Y0,Y1,Z0,Z1;
double Vx0,Vx1,Vy0,Vy1,Vz0,Vz1;

//---------------------------------------------------------------------------
void EditExit(TEdit *Edit, double *VAR, bool MoreThanZero, int Digits)
{
	if (!Edit->Modified) return;
    else Edit->Modified = false;
	double Var = 0;
    //	     :
	if (!sscanf(Edit->Text.c_str(), "%lf", &Var) || (Edit->Text.Trim()).Length()==0) {
        Edit->Text = Float2String(*VAR,Digits);
        return;
    }
    if (MoreThanZero && Var <= 0) {
        Edit->Text = Float2String(*VAR,Digits);
        return;
    }
	//	  :
    *VAR = Var;
    Edit->Text = Float2String(Var,Digits);
}
//---------------------------------------------------------------------------
__fastcall TGenBox::TGenBox(TComponent* Owner)
	: TForm(Owner)
{
	int W = MainForm->Image->Width;
    double F = double(W)/2/tan(Universe->Camera->Phi);	//  
	SpinEditNumber->Value = LastGen;
    R0 = 1;
    R1 = int(F/20) + 1;
    X0 = Universe->Camera->X0 - F/2;  X1 = Universe->Camera->X0 + F/2;
    Y0 = Universe->Camera->Y0 - F/2;  Y1 = Universe->Camera->Y0 + F/2;
    Z0 = Universe->Camera->Z0 - F/2;  Z1 = Universe->Camera->Z0 + F/2;
    Vx0 = -F/10;  Vx1 = F/10;
    Vy0 = -F/10;  Vy1 = F/10;
    Vz0 = -F/10;  Vz1 = F/10;
    EditR0->Text = Float2String(R0,7);
    EditR1->Text = Float2String(R1,7);
    if (!CheckBoxVisible->Checked) {
    	EditX0->Text = Float2String(X0,7);  EditX1->Text = Float2String(X1,7);
    	EditY0->Text = Float2String(Y0,7);  EditY1->Text = Float2String(Y1,7);
    	EditZ0->Text = Float2String(Z0,7);  EditZ1->Text = Float2String(Z1,7);
    }
    else {
    	EditX0->Text = "";  EditX1->Text = "";
    	EditY0->Text = "";  EditY1->Text = "";
    	EditZ0->Text = "";  EditZ1->Text = "";
    	EditX0->Enabled = false;  EditX1->Enabled = false;
    	EditY0->Enabled = false;  EditY1->Enabled = false;
    	EditZ0->Enabled = false;  EditZ1->Enabled = false;
    }
    EditVx0->Text = Float2String(Vx0,7);  EditVx1->Text = Float2String(Vx1,7);
    EditVy0->Text = Float2String(Vy0,7);  EditVy1->Text = Float2String(Vy1,7);
    EditVz0->Text = Float2String(Vz0,7);  EditVz1->Text = Float2String(Vz1,7);
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	Release();	
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::BtnCancelClick(TObject *Sender)
{
	Close();	
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditR0Exit(TObject *Sender)
{
	EditExit(EditR0,&R0,true,10);
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditR1Exit(TObject *Sender)
{
	EditExit(EditR1,&R1,true,10);
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditX0Exit(TObject *Sender)
{
	EditExit(EditX0,&X0,false,9);
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditX1Exit(TObject *Sender)
{
	EditExit(EditX1,&X1,false,9);
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditY0Exit(TObject *Sender)
{
	EditExit(EditY0,&Y0,false,9);
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditY1Exit(TObject *Sender)
{
	EditExit(EditY1,&Y1,false,9);
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditZ0Exit(TObject *Sender)
{
	EditExit(EditZ0,&Z0,false,9);
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditZ1Exit(TObject *Sender)
{
	EditExit(EditZ1,&Z1,false,9);
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditVx0Exit(TObject *Sender)
{
	EditExit(EditVx0,&Vx0,false,9);
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditVx1Exit(TObject *Sender)
{
	EditExit(EditVx1,&Vx1,false,9);
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditVy0Exit(TObject *Sender)
{
	EditExit(EditVy0,&Vy0,false,9);
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditVy1Exit(TObject *Sender)
{
	EditExit(EditVy1,&Vy1,false,9);
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditVz0Exit(TObject *Sender)
{
	EditExit(EditVz0,&Vz0,false,9);
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditVz1Exit(TObject *Sender)
{
	EditExit(EditVz1,&Vz1,false,9);
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditR0KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) EditR1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditR1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN)
    if (!CheckBoxVisible->Checked) EditX0->SetFocus();
    else EditVx0->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditX0KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) EditX1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditX1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) EditY0->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditY0KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) EditY1->SetFocus();	
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditY1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) EditZ0->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditZ0KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) EditZ1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditZ1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) EditVx0->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditVx0KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) EditVx1->SetFocus();	
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditVx1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) EditVy0->SetFocus();	
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditVy0KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) EditVy1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditVy1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) EditVz0->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditVz0KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) EditVz1->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::EditVz1KeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	if (Key == VK_RETURN) SpinEditNumber->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::BtnGenerateClick(TObject *Sender)
{
    if (R0 > R1) {
    	Application->MessageBox("      ","",MB_OK);
        EditR0->SetFocus();  return;
    }
    if (Vx0 > Vx1) {
    	Application->MessageBox("      ","",MB_OK);
        EditVx0->SetFocus();  return;
    }
    if (Vy0 > Vy1) {
    	Application->MessageBox("      ","",MB_OK);
        EditVy0->SetFocus();  return;
    }
    if (Vz0 > Vz1) {
    	Application->MessageBox("      ","",MB_OK);
        EditVz0->SetFocus();  return;
    }
    if (!CheckBoxVisible->Checked) {
    	if (X0 > X1) {
    		Application->MessageBox("      ","",MB_OK);
        	EditX0->SetFocus();  return;
    	}
    	if (Y0 > Y1) {
    		Application->MessageBox("      ","",MB_OK);
        	EditY0->SetFocus();  return;
    	}
    	if (Z0 > Z1) {
    		Application->MessageBox("      ","",MB_OK);
        	EditZ0->SetFocus();  return;
    	}
    }
    LastGen = SpinEditNumber->Value;
    GenBox->Visible = false;
    Screen->Cursor = crHourGlass;
    MainForm->Image->Update();
    if (CheckBoxVisible->Checked)
		Universe->RandomPlanets(LastGen, false, R0, R1, Vx0, Vx1, Vy0, Vy1, Vz0, Vz1);
    if (!CheckBoxVisible->Checked)
    	Universe->RandomPlanets(LastGen, R0, R1, X0, X1, Y0, Y1, Z0, Z1, Vx0, Vx1, Vy0, Vy1, Vz0, Vz1);

    Screen->Cursor = crDefault;
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TGenBox::CheckBoxVisibleClick(TObject *Sender)
{
	if (!CheckBoxVisible->Checked) {
    	EditX0->Enabled = true;  EditX1->Enabled = true;
    	EditY0->Enabled = true;  EditY1->Enabled = true;
    	EditZ0->Enabled = true;  EditZ1->Enabled = true;
    	EditX0->Text = Float2String(X0,7);  EditX1->Text = Float2String(X1,7);
    	EditY0->Text = Float2String(Y0,7);  EditY1->Text = Float2String(Y1,7);
    	EditZ0->Text = Float2String(Z0,7);  EditZ1->Text = Float2String(Z1,7);
    }
    else {
    	EditX0->Text = "";  EditX1->Text = "";
    	EditY0->Text = "";  EditY1->Text = "";
    	EditZ0->Text = "";  EditZ1->Text = "";
    	EditX0->Enabled = false;  EditX1->Enabled = false;
    	EditY0->Enabled = false;  EditY1->Enabled = false;
    	EditZ0->Enabled = false;  EditZ1->Enabled = false;
    }
}
//---------------------------------------------------------------------------
