//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TTrajSettingsBox.h"
#include "Unit1.h"
#include "TUniverse.cpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"
TTrajSettingsBox *TrajSettingsBox;

extern TUniverse *Universe;
extern int MAXPOINTS;
extern double DL;

//---------------------------------------------------------------------------
__fastcall TTrajSettingsBox::TTrajSettingsBox(TComponent* Owner)
	: TForm(Owner)
{
    int Sel = Universe->Selected;
	if (Sel > -1) {
    	MAXPOINTS = Universe->Planets[Sel]->Trajectory->GetMaxPoints();
        DL = Universe->Planets[Sel]->Trajectory->dL;
    }
    SpinEditMaxPoints->Value = MAXPOINTS;
    EditDL->Text = Float2String(DL, 9);
}
//---------------------------------------------------------------------------
void __fastcall TTrajSettingsBox::FormCloseQuery(TObject *Sender,
      bool &CanClose)
{
	Release();	
}
//---------------------------------------------------------------------------
void __fastcall TTrajSettingsBox::BtnCancelClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TTrajSettingsBox::SpinEditMaxPointsChange(TObject *Sender)
{
	MAXPOINTS = SpinEditMaxPoints->Value;
}
//---------------------------------------------------------------------------
void __fastcall TTrajSettingsBox::EditDLExit(TObject *Sender)
{
	if (!EditDL->Modified) return;
    else EditDL->Modified = false;
	double dL = 0;
    //	     :
	if (!sscanf(EditDL->Text.c_str(), "%lf", &dL) || (EditDL->Text.Trim()).Length()==0) {
        EditDL->Text = Float2String(DL,9);
        return;
    }
    if (dL < 0) {
        EditDL->Text = Float2String(DL,9);
        return;
    }
	//	  :
    DL = dL;
    EditDL->Text = Float2String(dL,9);
}
//---------------------------------------------------------------------------
void __fastcall TTrajSettingsBox::BtnOKClick(TObject *Sender)
{
//	    :
	if (!MainForm->SBtnGroup->Down) {
    	int Sel = Universe->Selected;
		if (Sel > -1) {
        	Universe->Planets[Sel]->Trajectory->SetMaxPoints(MAXPOINTS);
            Universe->Planets[Sel]->Trajectory->dL = DL;
        }
    }
//	    :
	if (MainForm->SBtnGroup->Down) {
    	for (int i=0; i<Universe->Count; i++)
        	if (Universe->Planets[i]->Selected) {
        		Universe->Planets[i]->Trajectory->SetMaxPoints(MAXPOINTS);
            	Universe->Planets[i]->Trajectory->dL = DL;
            }
    }
    Close();
}
//---------------------------------------------------------------------------
